
/*
** Copyright (C) 2005 Herbert Poetzl
**
** V0.01	device tag tool
**
*/

#define VERSION "V0.01"

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <stdint.h>


#include "vserver.h"
#include "switch.h"
#include "ngnet_cmd.h"
 

static	char	err_flag = 0;

static	char	opt_vers = 0;

static	char *	cmd_name = NULL;

static	int 	num_xid[2] = {~0,~0};
static	int 	num_ifidx = 0;




#define OPTIONS "+hi:x:y:V"

int	main(int argc, char *argv[])
{
        extern int optind;
        extern char *optarg;
        char c, errflg = 0;
	int r;


        cmd_name = argv[0];
        while ((c = getopt(argc, argv, OPTIONS)) != EOF) {
            switch (c) {
            case 'h':
                fprintf(stderr,
                    "This is %s " VERSION "\n"
                    "options are:\n"
                    "-h        print this help message\n"
                    "-i <num>  access interface index <num>\n"
                    "-x <num>  set primary xid to <num>\n"
                    "-y <num>  set secondary xid to <num>\n"
                    "-V        verify interface version\n"
                    "--        end of options\n"
                    ,cmd_name);
                exit(0);
                break;
            case 'i':
                num_ifidx = atol(optarg);
                break;
            case 'x':
                num_xid[0] = atol(optarg);
                break;
            case 'y':
                num_xid[1] = atol(optarg);
                break;
            case 'V':
                opt_vers = 1;
                break;
            case '?':
            default:
                errflg++;
                break;
            }
        }
        if (errflg) {
            fprintf(stderr, 
                "Usage: %s -[" OPTIONS "]\n"
                "%s -h for help.\n",
                cmd_name, cmd_name);
            exit(2);
        }

	if (opt_vers) {
	    r = vserver(VCMD_get_version, 0, NULL);
	    if (r<0)
	    	perror("vc_get_version");
    	    else 
	    	printf("version: %04x:%04x\n", 
		    (r>>16)&0xFFFF, r&0xFFFF);
	}

	{
	    struct vcmd_ngnet_tagdev vc_data;

	    vc_data.xid[0] = num_xid[0];
	    vc_data.xid[1] = num_xid[1];
		
	    r = vserver(VCMD_ngnet_tagdev, num_ifidx, &vc_data);
	    if (r<0)
	        perror("vc_ngnet_tagdev");
	} 
	
	exit((err_flag)?1:0);
}

